//
//  functions.cpp
//
//  Created by Daniel Blanquez on 02/12/2018.
//  Copyright © 2018 Daniel Blanquez. All rights reserved.
//

#include "functions.hpp"



bool battery_level(int battery_pin, int battery_treshold){
    double battery_value = analogRead(battery_pin)/1023*5;
    bool battery_charged;
    if (battery_value < battery_treshold) {
        battery_charged  = false;
    }
    else {
        battery_charged = true;
    }
    return battery_charged;
}

bool moisture_level(int moisture_pin, int moisture_treshold){
    int moisture_value = analogRead(moisture_pin);
    bool enough_moisture;
    if (moisture_value < moisture_treshold){
      enough_moisture = false;
    }
    else {
      enough_moisture = true;
    }
    return enough_moisture;
    }



int light_direction(int left_light_sensor_pin, int front_light_sensor_pin, int right_light_sensor_pin, double light_treshold){
     double left_sensor_value = analogRead(left_light_sensor_pin);
     double left_light_value = left_sensor_value/1023*5;
     double front_sensor_value = analogRead(front_light_sensor_pin);
     double front_light_value = front_sensor_value/1023*5;
     double right_sensor_value = analogRead(right_light_sensor_pin);
     double right_light_value = right_sensor_value/1023*5;
     int dir = 0;

     if ((right_light_value < light_treshold) && (front_light_value < light_treshold) && (left_light_value < light_treshold)){
      dir = 0;
     }
     if ((left_light_value >= front_light_value) && (left_light_value >= right_light_value)){
      dir = 1;
     }
     if ((front_light_value >= left_light_value) && (front_light_value >= right_light_value)){
      dir = 2;
     }
     if ((right_light_value >= front_light_value) && (right_light_value >= left_light_value)){
      dir = 3;
     }
     return dir;
  }


void follow_light (DualMC33926MotorShield md,int dir,int front_light_sensor_pin){
    if (dir == 2){
        md.setM1Speed(-100);
        md.setM2Speed(100);
    }

      if (dir == 1){
        md.setM1Speed(-100);
        md.setM2Speed(0);
      }

      if (dir ==3){
        md.setM1Speed(0);
        md.setM2Speed(100);
      }
  }

int obstacle (int sharp_pin_right,int sharp_pin_left,int sharp_pin_midle, double obstacle_treshold){
    int obstacle_dir = 0;
    double sensorValue_right = analogRead(sharp_pin_right);
    double sensorValue_left = analogRead(sharp_pin_left);
    double sensorValue_midle = analogRead(sharp_pin_midle);
    if ((sensorValue_midle > obstacle_treshold) and (sensorValue_right < obstacle_treshold) and (sensorValue_left < obstacle_treshold)){
       obstacle_dir = 3;
    }
    else if ((sensorValue_left > obstacle_treshold) and  (sensorValue_right < obstacle_treshold)){
        obstacle_dir = 1;
    }
    else if ((sensorValue_right > obstacle_treshold) and (sensorValue_left < obstacle_treshold)){
      obstacle_dir = 2;
    }
        return obstacle_dir;
  }

void stop_motors (DualMC33926MotorShield md){
  md.setM1Speed(0);
  md.setM2Speed(0);
}

bool enough_light(int left_light_sensor_pin, int front_light_sensor_pin, int right_light_sensor_pin){
     double left_sensor_value = analogRead(left_light_sensor_pin);
     double left_light_value = left_sensor_value/1023*5; //left_sensor_value/1023*5;
     double front_sensor_value = analogRead(front_light_sensor_pin);
     double front_light_value = front_sensor_value/1023*5;
     double right_sensor_value = analogRead(right_light_sensor_pin);
     double right_light_value = right_sensor_value/1023*5;
     bool enough_light = false;
     if ((left_light_value > 4.7) or (front_light_value > 4.7) or (right_light_value > 4.7)){
      enough_light = true;
     }
     else{
      enough_light = false;
     }
     return enough_light;
}

void avoid_obstacle (DualMC33926MotorShield md, int dir){
  if (dir == 1){
    md.setM2Speed(100);
    md.setM1Speed(0);
  }
  if (dir == 2){
    md.setM1Speed(-100);
    md.setM2Speed(0);
  }
  if (dir == 3){
    md.setM1Speed(0);
    md.setM2Speed(0);
  }

}


