//
//  functions.hpp
//
//  Created by Daniel Blanquez on 02/12/2018.
//  Copyright © 2018 Daniel Blanquez. All rights reserved.
//

#ifndef functions_hpp
#define function_hpp

#include <stdio.h>
#include <Arduino.h>
#include "DualMC33926MotorShield.h"

bool battery_level(int battery_pin, int battery_treshold);
bool moisture_level(int moisture_pin, int moisture_treshold);
int light_direction(int left_light_sensor_pin, int front_light_sensor_pin, int right_light_sensor_pin, double light_treshold);
void follow_light (DualMC33926MotorShield md,int dir,int front_light_sensor_pin);
int obstacle (int sharp_pin1,int sharp_pin2,int sharp_pin3,double obstacle_treshold);
void stop_motors (DualMC33926MotorShield md);
bool enough_light(int left_light_sensor_pin, int front_light_sensor_pin, int right_light_sensor_pin);
void avoid_obstacle (DualMC33926MotorShield md, int dir);

#endif
