
#include "functions.hpp"

int batteryPin = A3; // pin for measuring the level of tge battery
int hygroPin = A9; // pin for measuring the humidity
int left_light_sensor_pin = A4; // pins for measuring the light
int front_light_sensor_pin = A14;
int right_light_sensor_pin = A7;
int sharp_pin_right = A5;
int sharp_pin_left = A12;
int sharp_pin_midle = A10;
int pump_pin = 22;
int led_red = 24;
int led_green = 26;

double batteryLimit = 4; // limit of tension for functioning of the robot
double moistureTreshold = 500; // limit of humidity
int state = 2; // state of the robot
int light_dir = 0; // direction for light sensors, left = 1, front = 2 and rigth = 3
double light_treshold = 0.5; // limit of tension for light detection
double obstacle_treshold = 335; // 15 cm
DualMC33926MotorShield md; // define the motor controller
int obstacle_dir = 0;


void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200); // communication at 115200 bits/sec
  pinMode(batteryPin, INPUT); // analog input of the battery
  pinMode(hygroPin, INPUT); // analog input of the hygrometer
  pinMode(left_light_sensor_pin, INPUT); // analog input of the LDR's
  pinMode(front_light_sensor_pin, INPUT); 
  pinMode(right_light_sensor_pin, INPUT);
  pinMode(pump_pin, OUTPUT);
  md.init(); // intialization of the controler;

}

void loop() {
  // put your main code here, to run repeatedly:

  //Serial.println(state);
  while (state != 0){ // loop when all is functioning
    //Serial.println("state 0");
    if (state == 2){
      if (moisture_level(hygroPin, moistureTreshold)){ // if the plant has enough humidity
        digitalWrite (pump_pin, LOW);
        state = 3; // next state
        //Serial.println("enough water");
      }
      
      else{
        digitalWrite(pump_pin , HIGH); // should water the plant here
        //Serial.println("pumping");
      }
    }
    
    if (state == 3){
      light_dir = light_direction(left_light_sensor_pin, front_light_sensor_pin, right_light_sensor_pin, light_treshold); // direction the robot should go
      if (enough_light(left_light_sensor_pin, front_light_sensor_pin, right_light_sensor_pin)){
        stop_motors(md);
        //Serial.println("enough light");
      }
      else{
        obstacle_dir = obstacle(sharp_pin_right,sharp_pin_left,sharp_pin_midle,obstacle_treshold);
        Serial.println(obstacle_dir);
        if (obstacle_dir == 0){
          follow_light(md,light_dir,front_light_sensor_pin); // makes the robot follow the direction
          Serial.println("following light");
          }
        else{
          avoid_obstacle(md,obstacle_dir);
          Serial.println("avoiding obstacle");
        }
      }
    //Serial.println(state);
    delay(1000);
 }

  }
}
